#include <stdio.h>  
#include <stdlib.h>
#include <ctype.h>  

int multiply(double **, int, int, double **, int, int, double ***, int &, int &);

int main(){
int i,j;
    int m1,m2,m3;          
    int n1,n2,n3;          
    double **matrixA;   
    double **matrixB;   
    double **matrixC;   
    
    printf("Enter matrix A size, format - MxN: ");
    scanf("%dx%d", &m1, &n1);
    
    matrixA = (double **)malloc(sizeof(double *)*n1);
    for(i=0;i<n1;i++) {
       matrixA[i] = (double *)malloc(sizeof(double)*m1);
    }
    
    printf("Enter matrix A:\n");
    
    for(j=0;j<m1;j++) {   
       printf("Row %d: ",j);
       for(int i=0;i<n1;i++) {
           scanf("%lf", &(matrixA[i][j])); 
       }       
    }
    
     
    printf("Enter matrix B size, format - MxN: ");
    scanf("%dx%d", &m2, &n2);
    
    matrixB = (double **)malloc(sizeof(double *)*n2);
    for(i=0;i<n2;i++) {
       matrixB[i] = (double *)malloc(sizeof(double)*m2);
    }
    
    printf("Enter matrix B:\n");
    
    for(j=0;j<m2;j++) {   
       printf("Row %d: ",j);
       for(int i=0;i<n2;i++) {
           scanf("%lf", &(matrixB[i][j])); 
       }       
    }
    
    int result = multiply(matrixA, m1, n1, matrixB, m2, n2, &matrixC, m3, n3);
    
    if (result) {
        printf("Matrix C = AB, Size=%dx%d:\n", m3,n3);
        for(int i=0;i<m3;i++) {
           for(int j=0;j<n3;j++) {
              printf("%4.1f ",matrixC[j][i]);
           }
           printf("\n");       
        }
    } else {
         printf("Sizes not compatible\n");
    }
    
    
    
    for(i=0;i<m1;i++) {
      
       delete matrixA[i];
    }
    
    delete matrixA;
    
    for(i=0;i<m2;i++) {
       free(matrixB[i]);
    }
   
		delete (matrixB);
    
    for(i=0;i<m3;i++) {
      
		   delete(matrixC[i]);
    }
    
	delete	(matrixC);
    
    printf("Press any key to continue...");
    getchar();
}
int multiply(double **A, int m1, int n1, double **B, int m2, int n2, double ***C, int &m3, int &n3) {
    //          ,    
    if (n1==m2) {   
        m3=m1;  
        n3=n2;  
        
        *C = (double **)malloc(sizeof(double *)*n3);
        for(int i=0;i<n3;i++) {
           (*C)[i] = (double *)malloc(sizeof(double)*m3);
        }
        
        for(int k=0;k<m3;k++) {  
           for(int l=0;l<n3;l++) {
              double sum = 0;     
              for(int i=0;i<n1;i++) {       
                    sum+=A[i][k]*B[l][i];   
              }
              (*C)[l][k]=sum;               
           }        
        }
        return 1;  
                 
    } else {
        return 0;   
    }
}

